#!/usr/local/bin/perl

my @cv;
my @cl;
my @cd;
my @cp;
my @cs;

my @uv;
my @ul;
my @ud;
my @up;
my @us;

while (<>) {
  if ($_ =~ /med update [\S\s]+ ([\d.]+) \(v ([\d.]+) l ([\d.]+) d ([\d.]+) p ([\d.]+)/) {
    push @uv, $2;
    push @ul, $3-$2;
    push @ud, $4-$3;
    push @up, $5-$4;
    push @us, $1*1000-$5;
  }
  elsif
    ($_ =~ /med commit [\S\s]+ ([\d.]+) \(v ([\d.]+) l ([\d.]+) d ([\d.]+) c ([\d.]+) p ([\d.]+)/)
  {
    push @cv, $2;
    push @cl, $3-$2;
    push @cd, $5-$3;
    push @cp, $6-$5;
    push @cs, $1*1000-$6;
  }
}

sub sum {
  my @v = @_;
  $sum = 0;
  for ($i = 0; $i <= $#v; $i++) {
    $sum += $v[$i];
  }
  return $sum;
}

sub avg {
  my @v = @_;
  $sum = sum(@v);
  return $sum/($#v+1);
}

my $tt = avg(@uv) + avg (@ul) + avg(@ud) + avg(@up) + avg(@us);
printf ("# update: %4.1f %4.1f %4.1f %4.1f %4.1f = $tt\n",
        avg(@uv), avg(@ul), avg(@ud), avg(@up), avg(@us));

my $tt = avg(@cv) + avg (@cl) + avg(@cd) + avg(@cp) + avg(@cs);
printf ("# commit: %4.1f %4.1f %4.1f %4.1f %4.1f = $tt\n",
        avg(@cv), avg(@cl), avg(@cd), avg(@cp), avg(@cs));

