/*
 *  Copyright (C) 2002-2004  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef PASTWATCH_H
#define PASTWATCH_H

#include "stdinc.h"
#include "cfs.h"
#include "replica.h"
#include "cfsrw.h"

#define PASTWATCH_REF "Pastwatch"

struct pde_t {  // pastwatch directory entry
  str name;
  str path;
  str cfspath;
  cfs_ftype type;
  unsigned mode;
  bigint fh;
  bigint dirfh;
};

struct mtime_t {
  time_t sec;
  long nsec;
  mtime_t () { sec = 0; nsec = 0; }
};

inline void
pastwatch_status (str s, str path)
{
  strbuf b;
  if (s != "")
    b << s << " ";
  b << path << "\n";
  b.tosuio ()->output (1);
}

inline void
pastwatch_status (str s, str path, str msg)
{
  strbuf b;
  if (s != "")
    b << s << " ";
  b << path << ": " << msg << "\n";
  b.tosuio ()->output (1);
}

#endif

